<!--
  * t
  ****************************************************************************
  * Copyright 2018-2022,2023 Thomas E. Dickey                                *
  * Copyright 1998-2015,2017 Free Software Foundation, Inc.                  *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
  * "Software"), to deal in the Software without restriction, including      *
  * without limitation the rights to use, copy, modify, merge, publish,      *
  * distribute, distribute with modifications, sublicense, and/or sell       *
  * copies of the Software, and to permit persons to whom the Software is    *
  * furnished to do so, subject to the following conditions:                 *
  *                                                                          *
  * The above copyright notice and this permission notice shall be included  *
  * in all copies or substantial portions of the Software.                   *
  *                                                                          *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  *
  * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               *
  * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   *
  * IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   *
  * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    *
  * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    *
  * THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               *
  *                                                                          *
  * Except as contained in this notice, the name(s) of the above copyright   *
  * holders shall not be used in advertising or otherwise to promote the     *
  * sale, use or other dealings in this Software without prior written       *
  * authorization.                                                           *
  ****************************************************************************
  * @Id: curs_addch.3x,v 1.65 2023/08/19 19:45:54 tom Exp @
-->
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN">
<HTML>
<HEAD>
<meta http-equiv="Content-Type" content="text/html; charset=us-ascii">
<meta name="generator" content="Manpage converted by man2html - see https://invisible-island.net/scripts/readme.html#others_scripts">
<TITLE>curs_addch 3x 2023-08-19 ncurses 6.4 Library calls</TITLE>
<link rel="author" href="mailto:bug-ncurses@gnu.org">

</HEAD>
<BODY>
<H1 class="no-header">curs_addch 3x 2023-08-19 ncurses 6.4 Library calls</H1>
<PRE>
<STRONG><A HREF="curs_addch.3x.html">curs_addch(3x)</A></STRONG>                   Library calls                  <STRONG><A HREF="curs_addch.3x.html">curs_addch(3x)</A></STRONG>




</PRE><H2><a name="h2-NAME">NAME</a></H2><PRE>
       <STRONG>addch</STRONG>, <STRONG>waddch</STRONG>, <STRONG>mvaddch</STRONG>, <STRONG>mvwaddch</STRONG>, <STRONG>echochar</STRONG>, <STRONG>wechochar</STRONG> - add a character
       (with attributes) to a <STRONG>curses</STRONG> window, then advance the cursor


</PRE><H2><a name="h2-SYNOPSIS">SYNOPSIS</a></H2><PRE>
       <STRONG>#include</STRONG> <STRONG>&lt;curses.h&gt;</STRONG>

       <STRONG>int</STRONG> <STRONG>addch(const</STRONG> <STRONG>chtype</STRONG> <EM>ch</EM><STRONG>);</STRONG>
       <STRONG>int</STRONG> <STRONG>waddch(WINDOW</STRONG> <STRONG>*</STRONG><EM>win</EM><STRONG>,</STRONG> <STRONG>const</STRONG> <STRONG>chtype</STRONG> <EM>ch</EM><STRONG>);</STRONG>
       <STRONG>int</STRONG> <STRONG>mvaddch(int</STRONG> <EM>y</EM><STRONG>,</STRONG> <STRONG>int</STRONG> <EM>x</EM><STRONG>,</STRONG> <STRONG>const</STRONG> <STRONG>chtype</STRONG> <EM>ch</EM><STRONG>);</STRONG>
       <STRONG>int</STRONG> <STRONG>mvwaddch(WINDOW</STRONG> <STRONG>*</STRONG><EM>win</EM><STRONG>,</STRONG> <STRONG>int</STRONG> <EM>y</EM><STRONG>,</STRONG> <STRONG>int</STRONG> <EM>x</EM><STRONG>,</STRONG> <STRONG>const</STRONG> <STRONG>chtype</STRONG> <EM>ch</EM><STRONG>);</STRONG>

       <STRONG>int</STRONG> <STRONG>echochar(const</STRONG> <STRONG>chtype</STRONG> <EM>ch</EM><STRONG>);</STRONG>
       <STRONG>int</STRONG> <STRONG>wechochar(WINDOW</STRONG> <STRONG>*</STRONG><EM>win</EM><STRONG>,</STRONG> <STRONG>const</STRONG> <STRONG>chtype</STRONG> <EM>ch</EM><STRONG>);</STRONG>


</PRE><H2><a name="h2-DESCRIPTION">DESCRIPTION</a></H2><PRE>

</PRE><H3><a name="h3-Adding-characters">Adding characters</a></H3><PRE>
       The <STRONG>addch</STRONG>, <STRONG>waddch</STRONG>, <STRONG>mvaddch</STRONG> and <STRONG>mvwaddch</STRONG> routines put the  character  <EM>ch</EM>
       into  the  given  window  at its current window position, which is then
       advanced.  They are  analogous  to  <STRONG>putchar(3)</STRONG>  in  <STRONG>stdio(3)</STRONG>.   If  the
       advance is at the right margin:

       <STRONG>o</STRONG>   The cursor automatically wraps to the beginning of the next line.

       <STRONG>o</STRONG>   At  the bottom of the current scrolling region, and if <STRONG><A HREF="scrollok.3x.html">scrollok(3x)</A></STRONG>
           is enabled, the scrolling region is scrolled up one line.

       <STRONG>o</STRONG>   If <STRONG><A HREF="scrollok.3x.html">scrollok(3x)</A></STRONG> is not enabled, writing a character  at  the  lower
           right margin succeeds.  However, an error is returned because it is
           not possible to wrap to a new line

       If <EM>ch</EM> is a tab, newline, carriage return or backspace,  the  cursor  is
       moved appropriately within the window:

       <STRONG>o</STRONG>   Backspace  moves the cursor one character left; at the left edge of
           a window it does nothing.

       <STRONG>o</STRONG>   Carriage return moves the cursor to the window left margin  on  the
           current line.

       <STRONG>o</STRONG>   Newline  does  a <STRONG>clrtoeol</STRONG>, then moves the cursor to the window left
           margin on the next line, scrolling the window if on the last line.

       <STRONG>o</STRONG>   Tabs are considered to be at every eighth column.  The tab interval
           may be altered by setting the <STRONG>TABSIZE</STRONG> variable.

       If  <EM>ch</EM>  is  any  other nonprintable character, it is drawn in printable
       form, using the same convention as <STRONG><A HREF="unctrl.3x.html">unctrl(3x)</A></STRONG>:

       <STRONG>o</STRONG>   Control characters are displayed in the <STRONG>^</STRONG><EM>X</EM> notation.

       <STRONG>o</STRONG>   Values above 128 are either meta characters (if the screen has  not
           been  initialized,  or  if  <STRONG><A HREF="curs_inopts.3x.html">meta(3x)</A></STRONG>  has been called with a <STRONG>TRUE</STRONG> E
           parameter),  shown  in  the  <STRONG>M-</STRONG><EM>X</EM>  notation,  or  are  displayed  as
           themselves.   In  the latter case, the values may not be printable;
           this follows the X/Open specification.

       Calling <STRONG>winch</STRONG> after adding a nonprintable character does not return the
       character  itself,  but instead returns the printable representation of
       the character.

       Video attributes can be combined with a character  argument  passed  to
       <STRONG>addch</STRONG>  or  related  functions by logical-ORing them into the character.
       (Thus, text, including attributes, can be  copied  from  one  place  to
       another  using  <STRONG><A HREF="curs_inch.3x.html">inch(3x)</A></STRONG>  and  <STRONG>addch</STRONG>.)   See the <STRONG><A HREF="curs_attr.3x.html">curs_attr(3x)</A></STRONG> page for
       values of predefined video attribute constants  that  can  be  usefully
       OR'ed into characters.


</PRE><H3><a name="h3-Echoing-characters">Echoing characters</a></H3><PRE>
       The  <STRONG>echochar</STRONG>  and <STRONG>wechochar</STRONG> routines are equivalent to a call to <STRONG>addch</STRONG>
       followed by a call to <STRONG><A HREF="curs_refresh.3x.html">refresh(3x)</A></STRONG>, or a call to <STRONG>waddch</STRONG>  followed  by  a
       call  to <STRONG>wrefresh</STRONG>.  The knowledge that only a single character is being
       output  is  used  and,  for  non-control  characters,  a   considerable
       performance  gain  may be seen by using these routines instead of their
       equivalents.


</PRE><H3><a name="h3-Line-Graphics">Line Graphics</a></H3><PRE>
       The following variables may be used to add line drawing  characters  to
       the  screen  with  routines of the <STRONG>addch</STRONG> family.  The default character
       listed below is used if the <STRONG>acsc</STRONG> capability does not define a terminal-
       specific   replacement   for   it,   or  if  the  terminal  and  locale
       configuration requires  Unicode  but  the  library  is  unable  to  use
       Unicode.

       The names are taken from VT100 nomenclature.

       <STRONG>ACS</STRONG>            <STRONG>ACS</STRONG>       <STRONG>acsc</STRONG>   <STRONG>Glyph</STRONG>
       <STRONG>Name</STRONG>           <STRONG>Default</STRONG>   <STRONG>char</STRONG>   <STRONG>Name</STRONG>
       ---------------------------------------------------------
       ACS_BLOCK      #         0      solid square block
       ACS_BOARD      #         h      board of squares
       ACS_BTEE       +         v      bottom tee
       ACS_BULLET     o         ~      bullet
       ACS_CKBOARD    :         a      checker board (stipple)
       ACS_DARROW     v         .      arrow pointing down
       ACS_DEGREE     '         f      degree symbol
       ACS_DIAMOND    +         `      diamond
       ACS_GEQUAL     &gt;         &gt;      greater-than-or-equal-to
       ACS_HLINE      -         q      horizontal line
       ACS_LANTERN    #         i      lantern symbol
       ACS_LARROW     &lt;         ,      arrow pointing left
       ACS_LEQUAL     &lt;         y      less-than-or-equal-to
       ACS_LLCORNER   +         m      lower left-hand corner
       ACS_LRCORNER   +         j      lower right-hand corner
       ACS_LTEE       +         t      left tee
       ACS_NEQUAL     !         |      not-equal
       ACS_PI         *         {      greek pi
       ACS_PLMINUS    #         g      plus/minus
       ACS_PLUS       +         n      plus
       ACS_RARROW     &gt;         +      arrow pointing right
       ACS_RTEE       +         u      right tee
       ACS_S1         -         o      scan line 1
       ACS_S3         -         p      scan line 3
       ACS_S7         -         r      scan line 7
       ACS_S9         _         s      scan line 9
       ACS_STERLING   f         }      pound-sterling symbol
       ACS_TTEE       +         w      top tee
       ACS_UARROW     ^         -      arrow pointing up
       ACS_ULCORNER   +         l      upper left-hand corner
       ACS_URCORNER   +         k      upper right-hand corner
       ACS_VLINE      |         x      vertical line


</PRE><H2><a name="h2-RETURN-VALUE">RETURN VALUE</a></H2><PRE>
       All routines return the integer <STRONG>ERR</STRONG> upon failure and <STRONG>OK</STRONG> on success (the
       SVr4 manuals specify only "an  integer  value  other  than  <STRONG>ERR</STRONG>")  upon
       successful  completion, unless otherwise noted in the preceding routine
       descriptions.

       Functions with a "mv" prefix first  perform  a  cursor  movement  using
       <STRONG>wmove</STRONG>, and return an error if the position is outside the window, or if
       the window pointer is null.

       If it is not  possible  to  add  a  complete  character,  an  error  is
       returned:

       <STRONG>o</STRONG>   If  <STRONG><A HREF="scrollok.3x.html">scrollok(3x)</A></STRONG>  is  not enabled, writing a character at the lower
           right margin succeeds.  However, an error is returned because it is
           not possible to wrap to a new line

       <STRONG>o</STRONG>   If  an error is detected when converting a multibyte character to a
           sequence of bytes, or if it is not  possible  to  add  all  of  the
           resulting bytes in the window, an error is returned.


</PRE><H2><a name="h2-NOTES">NOTES</a></H2><PRE>
       Note that <STRONG>addch</STRONG>, <STRONG>mvaddch</STRONG>, <STRONG>mvwaddch</STRONG>, and <STRONG>echochar</STRONG> may be macros.


</PRE><H2><a name="h2-PORTABILITY">PORTABILITY</a></H2><PRE>
       All  these functions are described in the XSI Curses standard, Issue 4.
       The defaults specified for forms-drawing characters apply in the  POSIX
       locale.


</PRE><H3><a name="h3-ACS-Symbols">ACS Symbols</a></H3><PRE>
       X/Open Curses states that the <STRONG>ACS_</STRONG> definitions are <STRONG>char</STRONG> constants.  For
       the  wide-character  implementation  (see  <STRONG>curs_add_wch</STRONG>),   there   are
       analogous   <STRONG>WACS_</STRONG>   definitions  which  are  <STRONG>cchar_t</STRONG>  constants.   Some
       implementations are problematic:

       <STRONG>o</STRONG>   Some implementations define the ACS symbols to a constant (such  as
           Solaris), while others define those to entries in an array.

           This  implementation uses an array <STRONG>acs_map</STRONG>, as done in SVr4 curses.
           NetBSD also uses an array, actually named <STRONG>_acs_char</STRONG>, with a <STRONG>#define</STRONG>
           for compatibility.

       <STRONG>o</STRONG>   HPUX curses equates some of the <STRONG>ACS_</STRONG> symbols to the analogous <STRONG>WACS_</STRONG>
           symbols  as  if  the  <STRONG>ACS_</STRONG>  symbols  were  wide  characters.    The
           misdefined  symbols  are the arrows and other symbols which are not
           used for line-drawing.

       <STRONG>o</STRONG>   X/Open Curses (issues 2 through 7) has a  typographical  error  for
           the  ACS_LANTERN  symbol,  equating  its  "VT100+  Character"  to <STRONG>I</STRONG>
           (capital I), while the header files for SVr4 curses and the various
           implementations use <STRONG>i</STRONG> (lowercase).

           None  of the terminal descriptions on Unix platforms use uppercase-
           I,  except  for  Solaris  (i.e.,  <STRONG>screen</STRONG>'s  terminal   description,
           apparently  based on the X/Open documentation around 1995).  On the
           other hand, the terminal description <EM>gs6300</EM> (AT&amp;T PC6300 with EMOTS
           Terminal Emulator) uses lowercase-i.

       Some  ACS  symbols  (ACS_S3,  ACS_S7,  ACS_LEQUAL,  ACS_GEQUAL, ACS_PI,
       ACS_NEQUAL, ACS_STERLING) were not documented in any publicly  released
       System  V.   However,  many  publicly  available terminfos include <STRONG>acsc</STRONG>
       strings in which their key characters (pryz{|})  are  embedded,  and  a
       second-hand  list  of  their  character descriptions has come to light.
       The ACS-prefixed names for them were invented for <STRONG><A HREF="ncurses.3x.html">ncurses(3x)</A></STRONG>.

       The <EM>displayed</EM> values for the <STRONG>ACS_</STRONG> and <STRONG>WACS_</STRONG> constants depend on

       <STRONG>o</STRONG>   the library configuration, i.e., <STRONG>ncurses</STRONG> versus <STRONG>ncursesw</STRONG>, where the
           latter  is  capable  of displaying Unicode while the former is not,
           and

       <STRONG>o</STRONG>   whether the <EM>locale</EM> uses UTF-8 encoding.

       In certain cases,  the  terminal  is  unable  to  display  line-drawing
       characters   except   by   using   UTF-8   (see   the   discussion   of
       <STRONG>NCURSES_NO_UTF8_ACS</STRONG> in <STRONG><A HREF="ncurses.3x.html">ncurses(3x)</A></STRONG>).


</PRE><H3><a name="h3-Character-Set">Character Set</a></H3><PRE>
       X/Open Curses assumes that the parameter passed to  <STRONG>waddch</STRONG>  contains  a
       single  character.   As  discussed in <STRONG><A HREF="curs_attr.3x.html">curs_attr(3x)</A></STRONG>, that character may
       have been more than eight bits in an SVr3 or SVr4  implementation,  but
       in  the  X/Open Curses model, the details are not given.  The important
       distinction between SVr4 curses and X/Open  Curses  is  that  the  non-
       character  information  (attributes  and  color) was separated from the
       character information which is packed in a <STRONG>chtype</STRONG> to pass to <STRONG>waddch</STRONG>.

       In this implementation,  <STRONG>chtype</STRONG>  holds  an  eight-bit  character.   But
       ncurses  allows  multibyte  characters  to be passed in a succession of
       calls to <STRONG>waddch</STRONG>.  The other implementations do not do this; a  call  to
       <STRONG>waddch</STRONG>  passes  exactly  one  character which may be rendered as one or
       more cells on the screen depending on whether it is printable.

       Depending on the locale settings, ncurses will inspect the byte  passed
       in  each  call  to <STRONG>waddch</STRONG>, and check if the latest call will continue a
       multibyte sequence.  When a character is <EM>complete</EM>, ncurses displays the
       character and moves to the next position in the screen.

       If  the  calling  application  interrupts  the succession of bytes in a
       multibyte character by moving the current location (e.g., using <STRONG>wmove</STRONG>),
       ncurses discards the partially built character, starting over again.

       For  portability  to  other  implementations,  do  not  rely  upon this
       behavior:

       <STRONG>o</STRONG>   check if a character can be represented as a  single  byte  in  the
           current locale before attempting call <STRONG>waddch</STRONG>, and

       <STRONG>o</STRONG>   call <STRONG>wadd_wch</STRONG> for characters which cannot be handled by <STRONG>waddch</STRONG>.


</PRE><H3><a name="h3-TABSIZE">TABSIZE</a></H3><PRE>
       The  <STRONG>TABSIZE</STRONG>  variable  is  implemented  in  SVr4 and other versions of
       curses, but is not part of X/Open curses  (see  <STRONG><A HREF="curs_variables.3x.html">curs_variables(3x)</A></STRONG>  for
       more details).

       If <EM>ch</EM> is a carriage return, the cursor is moved to the beginning of the
       current row of the window.  This is true of other implementations,  but
       is not documented.


</PRE><H2><a name="h2-SEE-ALSO">SEE ALSO</a></H2><PRE>
       <STRONG><A HREF="ncurses.3x.html">curses(3x)</A></STRONG>,      <STRONG><A HREF="curs_attr.3x.html">curs_attr(3x)</A></STRONG>,      <STRONG><A HREF="curs_clear.3x.html">curs_clear(3x)</A></STRONG>,     <STRONG><A HREF="curs_inch.3x.html">curs_inch(3x)</A></STRONG>,
       <STRONG><A HREF="curs_outopts.3x.html">curs_outopts(3x)</A></STRONG>, <STRONG><A HREF="curs_refresh.3x.html">curs_refresh(3x)</A></STRONG>, <STRONG><A HREF="curs_variables.3x.html">curs_variables(3x)</A></STRONG>, <STRONG>putc(3)</STRONG>.

       Comparable functions  in  the  wide-character  (ncursesw)  library  are
       described in <STRONG><A HREF="curs_add_wch.3x.html">curs_add_wch(3x)</A></STRONG>.



ncurses 6.4                       2023-08-19                    <STRONG><A HREF="curs_addch.3x.html">curs_addch(3x)</A></STRONG>
</PRE>
<div class="nav">
<ul>
<li><a href="#h2-NAME">NAME</a></li>
<li><a href="#h2-SYNOPSIS">SYNOPSIS</a></li>
<li><a href="#h2-DESCRIPTION">DESCRIPTION</a>
<ul>
<li><a href="#h3-Adding-characters">Adding characters</a></li>
<li><a href="#h3-Echoing-characters">Echoing characters</a></li>
<li><a href="#h3-Line-Graphics">Line Graphics</a></li>
</ul>
</li>
<li><a href="#h2-RETURN-VALUE">RETURN VALUE</a></li>
<li><a href="#h2-NOTES">NOTES</a></li>
<li><a href="#h2-PORTABILITY">PORTABILITY</a>
<ul>
<li><a href="#h3-ACS-Symbols">ACS Symbols</a></li>
<li><a href="#h3-Character-Set">Character Set</a></li>
<li><a href="#h3-TABSIZE">TABSIZE</a></li>
</ul>
</li>
<li><a href="#h2-SEE-ALSO">SEE ALSO</a></li>
</ul>
</div>
</BODY>
</HTML>
